/**
 * Created by Administrator on 2016/1/20.
 * 统计任务
 */

var analyse = require('./analyse.js');
var taskLogService = require('./../service/tasklog.js');
var pageViewService = require('./../service/pageview.js');
var pageViewAllService = require('./../service/pageviewall.js');
var stateService = require('./../service/state.js');
var stateBService = require('./../service/stateb.js');
var movedata = require('./movedata.js');
var schedule = require('node-schedule');

var main = function () {
    /*stateBService.find({
     event: 'init',
     createtime : {$gte: new Date('2016-1-24 00:00:00'), $lt: new Date('2016-1-24 23:59:59')}
     }, function (list) {
     console.log('###:' + list.length);
     /!*list.forEach(function (o) {
     console.log('###data:' + JSON.stringify(o));
     });*!/
     });*/
    /*stateService.model.find({
     event: 'init',
     }).sort({createtime: -1}).limit(2).exec(function(err, list){
        console.log('!!!:' + JSON.stringify(list));
    });*/

    /*pageViewService.model.count( function(err, count){
     console.log('@@@:' + count);
     })*/

    //_testRemove();

    //_testAdd();
    //_testPv();

    /*var day = new Date();
     analyse.statPVByDay(day);*/

    /*pageViewAllService.find(function(list){
     console.log('pageViewAllService :' + JSON.stringify(list));
     });*/

    function _doTask(cb, taskDes){
        var currDate = new Date();
        var newDate = new Date(+currDate - 24 * 60 * 60 * 1000);
        cb && cb({time: newDate, des: taskDes});
        console.log(taskDes + ' 任务被执行在:' + (currDate.toString()));
    }

    /**
     * 定时任务策略，先统计昨天的数据，再将数据迁移到B表。
     * 好处: A表只有两天的数据，可提高查询统计的效率
     */
    schedule.scheduleJob({hour: 0, minute: 10}, function () {
        _doTask(function(d){
            _statPV(d, null, true);
        }, '时间段汇总');
    });

    schedule.scheduleJob({hour: 0, minute: 20}, function () {
        _doTask(function(d){
            _statPVAll(d, null, true);
        }, '一天汇总');
    });

    schedule.scheduleJob({hour: 0, minute: 30}, function () {
        _doTask(function(d){
            _statPagePVByDay(d, null, true);
        }, '页面排行');
    });

    /**
     * 将数据从表state转移到stateB
     */
    schedule.scheduleJob({hour: 5, minute: 0}, function () {
        _doTask(function(d){
            _moveData(d);
        }, '数据迁移');
    });

    //_testRestoreDate();

    /*stateBService.find({
        time: new Date(1453992844594)
    }, function(list){
        console.log('@@@:' + JSON.stringify(list));
    });*/
};

function _d(d, cb, cb2){
    if (!d.time) {
        console.error('缺少时间');
    }
    taskLogService.add(d, function (obj) {
        cb && cb(obj);
    });
    cb2 && cb2(d.time);
}

function _moveData(d, cb){
    _d(d, cb, function(time){
        movedata.moveFromStateToStateB(time);
    });
}

/**
 * 一天按分时段统计
 * @param d: time author des
 * @param cb
 * @private
 */
function _statPV(d, cb, isA) {
    _d(d, cb, function(time){
        analyse.statPVByDay(time, isA);
    });
}

/**
 * 统计一天的数据汇总
 * @param d
 * @param cb
 * @private
 */
function _statPVAll(d, cb, isA) {
    _d(d, cb, function(time){
        analyse.statAllDataByDay(time, isA);
    });
}

//统计页面pv排行
function _statPagePVByDay(d, cb, isA) {
    _d(d, cb, function(time){
        analyse.statPagePVByDay(time, isA);
    });
}


/*function _testRemove() {
    var TaskLogModel = taskLogService.model;
    TaskLogModel.remove(function (err, list) {
        console.log('已删除：' + JSON.stringify(list));
    });

    var PageViewModel = pageViewService.model;
    PageViewModel.remove(function (err, list) {
        console.log('已删除：' + JSON.stringify(list));
    });

    var StateModel = stateService.model;
    StateModel.remove(function (err, list) {
        console.log('已删除：' + JSON.stringify(list));
    });

    var StateBModel = stateBService.model;
    StateBModel.remove(function (err, list) {
        console.log('已删除：' + JSON.stringify(list));
    });
}

function _testRestoreDate() {
    //恢复数据 stateB 转移到 state
    //删除pageview
    var StateBModel = stateBService.model;
    stateBService.find(function (list) {
        list.forEach(function (o) {
            stateService.add(o, function (obj) {
                console.log('save stateB success:' + JSON.stringify(obj));
                StateBModel.remove(o, function (err, list) {
                    if (err) console.err(err);
                    console.log('remove state success:' + JSON.stringify(list));
                });
            });
        });
    });

    var PageViewModel = pageViewService.model;
    PageViewModel.remove(function (err, list) {
        console.log('已删除 pageview：' + JSON.stringify(list));
    });
}*/

main.doMoveData = function(d, cb){
    _moveData(d, cb);
};
main.doStatPV = function (d, cb) {
    _statPV(d, cb);
};
main.doStatPVAll = function (d, cb) {
    _statPVAll(d, cb);
};
main.doStatPagePVByDay = function (d, cb) {
    _statPagePVByDay(d, cb);
};

/**
 * 更新 pageView 的 sn
 * @private
 */
/*function _alterViewPage(){
 var Model = pageViewService.model;
 pageViewService.find(function (list) {
 list.forEach(function(o){
 var startTime = o.startTime,
 endTime = o.endTime;
 var beTime = new Date((startTime.valueOf() + endTime.valueOf())/2);
 var minu = beTime.getHours()*60 + beTime.getMinutes();
 var sn = Math.floor(minu/10);
 Model.findOneAndUpdate(o, {sn: sn}, function(err, result){
 if(err) console.error(err);
 console.log('update pageview success: ' + JSON.stringify(result));
 });
 });
 });
 }*/

module.exports = main;