/**
 * Created by Administrator on 2016/1/15.
 */
var express = require('express');
var baseRoute = require('./base.js');
var service = require('../service/state.js');
var stateUserService = require('../service/stateuser.js');
var router = express.Router();

router.get('/', function(req, res, next){
    var q = req.query;
    var data = {};
    for(var i in q){
        data[i] = q[i];
    }
    data.time = new Date(parseInt(q.time));
    data.ip = req._remoteAddress;
    service.add(data);
    var options = {
        root: __dirname.replace('routes', 'public')
    };
    res.sendFile('/img/state.gif', options);
});
router.get('/find', function(req, res, next){
    service.find(null, baseRoute.success.bind(res), baseRoute.fail.bind(res));
});
/**
 * 创建cuid
 */
router.get('/creatcuid', function(req, res, next){
    var cuid = stateUserService.getObjectId();
    stateUserService.add({cuid: cuid});
    res.jsonp({cuid: cuid});
});
router.get('/createcuid', function(req, res, next){
    var cuid = stateUserService.getObjectId();
    stateUserService.add({cuid: cuid});
    res.jsonp({cuid: cuid});
});

router.get('/findcuid', function(req, res, next){
    stateUserService.find(null, baseRoute.success.bind(res), baseRoute.fail.bind(res));
});


module.exports = router;