var express = require('express');
var baseRoute = require('./base.js');
var service = require('../service/user.js');
var router = express.Router();


/* GET users listing. */
router.get('/add', function (req, res, next) {
    var d = req.query;
    service.add(d, baseRoute.success.bind(res), baseRoute.fail.bind(res));
});
router.get('/find', function (req, res, next) {
    service.find(null, baseRoute.success.bind(res), baseRoute.fail.bind(res));
});

module.exports = router;
