/**
 * Created by Administrator on 2016/1/26.
 */
var stateService = require('./../service/state.js');
var stateBService = require('./../service/stateb.js');
var dateutil = require('../modules/dateutil.js');

var moveFromStateToStateB = function(targetDate){
    var startAndEndTime = dateutil.getStartAndEndInDay(targetDate);
    stateService.find({
        createtime: {$gte: startAndEndTime.startTime, $lt: startAndEndTime.endTime}
    }, function(list){
        console.log('被迁移的数据总量:' + list.length);
        list.forEach(function (o) {
            _moveData(o);
        });
    });

    function _moveData(o) {
        stateBService.add(o, function (obj) {
            //console.log('save stateB success:' + JSON.stringify(obj));
            stateService.model.remove(o, function (err, list) {
                if (err) console.err(err);
                //console.log('remove state success:' + JSON.stringify(list));
            });
        });
    }
};

module.exports = {
    moveFromStateToStateB: moveFromStateToStateB
};