/**
 * Created by Administrator on 2016/1/21.
 */
/*
 时间格式化方法
 param： str format
 例子：('yyyy-MM-dd h:m:s');
 */
Date.prototype.format = function(format) {
    var date = {
        "M+": this.getMonth() + 1,
        "d+": this.getDate(),
        "h+": this.getHours(),
        "m+": this.getMinutes(),
        "s+": this.getSeconds(),
        "q+": Math.floor((this.getMonth() + 3) / 3),
        "S+": this.getMilliseconds()
    };
    if (/(y+)/i.test(format)) {
        format = format.replace(RegExp.$1, (this.getFullYear() + '').substr(4 - RegExp.$1.length));
    }
    for (var k in date) {
        if (new RegExp("(" + k + ")").test(format)) {
            format = format.replace(RegExp.$1, RegExp.$1.length == 1 ? date[k] : ("00" + date[k]).substr(("" + date[k]).length));
        }
    }
    return format;
}

function convertTimeToStr(val) {
    var date = new Date(val);
    var arr1 = [];
    var arr2 = [];
    arr1.push(_getStr(date.getFullYear())),
        arr1.push(_getStr(date.getMonth() + 1)),
        arr1.push(_getStr(date.getDate())),
        arr2.push(_getStr(date.getHours())),
        arr2.push(_getStr(date.getMinutes())),
        arr2.push(_getStr(date.getSeconds()));

    function _getStr(v) {
        var s = v + '';
        if (s.length == 1) {
            return '0' + s;
        } else {
            return s;
        }
    }
    return arr1.join('-') + ' ' + arr2.join(':');
}

/**
 * 2015-07-12 10:10:10 ->Date对象
 */
function getDateByStr(str){
    var arr = str.split(' ');
    var arrA = arr[0].split('-'),
        arrB = arr[1].split(':');
    return new Date(d(arrA[0]), d(arrA[1])-1, d(arrA[2]), d(arrB[0]), d(arrB[1]), d(arrB[2]), 0);

    function d(v){
        return parseInt(v);
    }
}

/**
 * 获得某一天的开始和结束时间
 * @param date
 */
function getStartAndEndInDay(date){
    var str = convertTimeToStr(date);
    var newStr = str.substr(0, 10) + ' 00:00:00';
    var startTime = getDateByStr(newStr);
    var endTime = new Date(startTime.valueOf() + 24*60*60*1000);
    return {
        startTime: startTime,
        endTime: endTime
    };
}

module.exports = {
    convertTimeToStr: convertTimeToStr,
    getDateByStr: getDateByStr,
    getStartAndEndInDay: getStartAndEndInDay
}