/**
 * Created by Administrator on 2016/1/19.
 */
(function(){
    function getFormData(ele){
        var arr = $(ele).serializeArray();
        var result = {};
        $.each(arr, function(i, d){
            if(result.hasOwnProperty(d.name) && d.value){
                result[d.name] += ',' + d.value;
            }else{
                result[d.name] = d.value;
            }
        });
        return result;
    }
    function template(str, data){
        return str.replace(/\{(\w+)\}/g, function(s1, s2){
            if(data.hasOwnProperty(s2)){
                return data[s2];
            }else{
                return s1;
            }
        });
    }

    var BBM = window["BBM"] || {};
    BBM.getFormData = getFormData;
    BBM.template = template;
    window["BBM"] = BBM;
})();