/**
 * Created by Administrator on 2016/1/15.
 */
var mongoose = require('../modules/mongoose.js');
/**
 * 基类
 * @param className
 * @param schema
 */
function base(className, schema) {
    var SpeSchema = mongoose.Schema(schema);
    this.model = mongoose.model(className, SpeSchema);
}
base.prototype.add = function(d, success, fail){
    var s = new this.model(d);
    s.save(function (err, o) {
        if (err) {
            console.error(err);
            fail && fail(err);
        } else {
            success && success(o);
        }
    });
};
base.prototype.find = function(d, success, fail) {
    if(typeof d === 'function'){
        fail = success,
            success = d;
        this.model.find(_do);
    }else{
        this.model.find(d, _do);
    }
    function _do(err, list) {
        if (err) {
            console.error(err);
            fail && fail(err);
        } else {
            success && success(list);
        }
    }
};
base.prototype.getMongoose = function(d){
    return mongoose;
};
base.prototype.getObjectId = function () {
    return new mongoose.Types.ObjectId;
}
module.exports = base;
